/*
 *  extend.h - extended aplay definitions
 *
 *  extended by NAKATA Hiroshi <webmaster@nakata-jp.org>
 *
 *  Original aplay.c source is
 *  Copyright (c) by Jaroslav Kysela <perex@perex.cz>
 *  Based on vplay program by Michael Beck
 *
 *  
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 */

#include <alsa/asoundlib.h>

#define	NOT_BIT_PERFECT

struct _hwparams {
	snd_pcm_format_t format;
	snd_pcm_format_t device_format;
	unsigned int channels;
	unsigned int rate;
};

typedef struct _formatinfo {
	char *name;
	int bit_depth;
	int bit_pack;
} _formatinfo;

extern _formatinfo format_info[];
extern int snd_pcm_hw_params_set_format_ex(snd_pcm_t *handle,
					   snd_pcm_hw_params_t *params,
					   struct _hwparams *hwparams,
					   const int quiet_mode,
					   snd_pcm_stream_t stream);
extern unsigned int extended_len(const struct _hwparams *hwparams,
				 const unsigned int source_len);
extern unsigned int unextended_len(const struct _hwparams *hwparams,
				   const unsigned int source_len);
extern int convert_buffer(const int input_format,
			  const int output_format,
			  const int channels,
			  u_char *device_buf,
			  const u_char *read_buf,
			  const int count);

